#ifndef _H_RAINDROPCRYTYPE_
#define _H_RAINDROPCRYTYPE_

#include <stdio.h>
#include <string.h> 
#include <immintrin.h>
#include <stdint.h> 

#define Dirt_ENC 0
#define Dirt_DEC 1

#define LONGTEXTLEN (2*1024*1024)

#ifndef RoundRainDrop128128
#define RoundRainDrop128128  60
#endif

#ifndef RoundRainDrop128256
#define RoundRainDrop128256 80
#endif

#ifndef RoundRainDrop256256
#define RoundRainDrop256256  100
#endif  
 
 

 #ifndef u8i
   #define u8i unsigned char
#endif

#ifndef u16i
   #define u16i uint16_t
#endif

#ifndef u32i
   #define u32i uint32_t 
#endif

#ifndef u64i
   #define u64i  uint64_t
#endif

#ifndef u128i   
   #define u128i __m128i  
#endif


#ifdef  __GNUC__
   #define _C_ALIGN(n, A)  A __attribute__ ((aligned (n)))
#elif _MSC_VER 
   #define _C_ALIGN(n, A)  __declspec( align(n) ) A
#endif

#define _C_ALIGN16(A) _C_ALIGN(16,A)
#define _C_ALIGN32(A) _C_ALIGN(32,A)

#define  Sbox35(l2) \
	t0= (l2<<1)& 0xDEDE;\
	t1= (l2>>2)& 0x2020;\
	t4= (l2>>4)& 0x0101;\
	t2= (l2<<2)& 0x9C9C;\
	t3= (l2>>1)& 0x6060;\
	t5= (l2>>3)& 0x0303;\
	l2=  l2^((~(t0|t1|t4 ))&(t2|t3|t5));


#define Fun_B(T,b,a,tmp)\
	T##7^= (T##0>>10);\
	tmp=T##7<<b;\
	T##6^=(T##1>>15);\
	T##7=(T##7>>a)|(T##6<<b);\
	T##5^=(T##2>>15);\
	T##6=(T##6>>a)|(T##5<<b);\
	T##5=(T##5>>a)|(T##4<<b);\
	T##4=(T##4>>a)|(T##3<<b);\
	T##3=(T##3>>a)|(T##2<<b);\
	T##2=(T##2>>a)|(T##1<<b);\
	T##1=(T##1>>a)|(T##0<<b);\
	T##0=(T##0>>a)|tmp; 

#define Fun_A(T,b,a,tmp)\
	T##7^= (T##1>>25);\
	tmp=T##7<<b;\
	T##6^=(T##0>>26);\
	T##7=(T##7>>a)|(T##6<<b);\
	T##5^=(T##3<<29);\
	T##6=(T##6>>a)|(T##5<<b);\
	T##5=(T##5>>a)|(T##4<<b);\
	T##4=(T##4>>a)|(T##3<<b);\
	T##3=(T##3>>a)|(T##2<<b);\
	T##2=(T##2>>a)|(T##1<<b);\
	T##1=(T##1>>a)|(T##0<<b);\
	T##0=(T##0>>a)|tmp;
 

/******************************
swap   rotate 
********************************/
#define ROTL4(v, n) \
	(((v) << (n)) | ((v) >> (4 - (n)))) 

#define ROTL8(v, n) \
	((u8i)((v) << (n)) | ((v) >> (8 - (n)))) 

#define ROTL16(v, n) \
	((u16i)((v) << (n)) | ((v) >> (16 - (n)))) 

#define ROTR16(v, n) \
	((u16i)((v) >> (n)) | ((v) << (16 - (n))))   

#define SWAP16(v)\
	ROTL16(v, 8)

#define ROTL32(v, n) \
	((u32i)((v) << (n)) | ((v) >> (32 - (n))))

#define ROTR32(v, n) \
	((u32i)((v) >> (n)) | ((v) <<(32 - (n))))

#define SWAP32(v) \
	((ROTL32(v,  8) & (u32i)(0x00FF00FF)) | \
	(ROTL32(v, 24) & (u32i)(0xFF00FF00))) 

#define SWAP64(v) \
	(((u64i)SWAP32((u32i)(v)) << 32) | (u64i)SWAP32((u32i)(v >> 32)))


#define ROTL64(v, n) \
	((u64i)((v) << (n)) | ((v) >> (64 - (n))))
 
  
#define ROTL128(out,A,n, C,B)\
	B=_mm_srli_epi64(A,n);\
	C=_mm_slli_epi64(A,64-n);\
	C= _mm_shuffle_epi32(C,0x4e);\
	out= _mm_xor_si128(B,C); 

#define ROTR128(out,A,n, C,B)\
	B=_mm_slli_epi64(A,n);\
	C=_mm_srli_epi64(A,64-n);\
	C= _mm_shuffle_epi32(C,0x4e);\
	out= _mm_xor_si128(B,C);

#define Fun_B_SimdB(A,B,C,D,N0,N1,N2,N3)\
	ROTL128(N1,A,11, B,C);\
	ROTL128(N0,A,44, B,C);\
	D=_mm_xor_si128(N0,_mm_and_si128(N1, MASK0));\
	ROTL128(N3,A,5, B,C);\
	D=_mm_xor_si128(D,_mm_and_si128(N3, MASK1));\
	B=_mm_and_si128(_mm_slli_epi64(N0,6), MASK2);\
	N3= _mm_xor_si128(B,_mm_slli_epi64(B,6));\
	N3=_mm_and_si128( N3,MASK2);\
	D=_mm_xor_si128(N3,D);\
	ROTR128(C,A,21,B,C);\
	N1=_mm_and_si128(C, MASK5);\
	N0=_mm_slli_epi64(C,1);\
	N0=_mm_and_si128(N0, MASK7);\
	N2=_mm_slli_epi64(C,6);\
	A=_mm_and_si128(N2, MASK6);\
	A=	_mm_xor_si128(_mm_xor_si128(A,D),_mm_xor_si128(N0,N1));


#endif